diff -urNb sbcl/src/code/run-program.lisp sbcl.char/src/code/run-program.lisp
--- sbcl/src/code/run-program.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/run-program.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -289,12 +289,12 @@
 (defun find-a-pty ()
   (dolist (char '(#\p #\q))
     (dotimes (digit 16)
-      (let* ((master-name (format nil "/dev/pty~C~X" char digit))
+      (let* ((master-name (coerce (format nil "/dev/pty~C~X" char digit) 'base-string))
 	     (master-fd (sb-unix:unix-open master-name
 					   sb-unix:o_rdwr
 					   #o666)))
 	(when master-fd
-	  (let* ((slave-name (format nil "/dev/tty~C~X" char digit))
+	  (let* ((slave-name (coerce (format nil "/dev/tty~C~X" char digit) 'base-string))
 		 (slave-fd (sb-unix:unix-open slave-name
 					      sb-unix:o_rdwr
 					      #o666)))
@@ -347,7 +347,9 @@
 	(declare (simple-string s))
 	(let ((n (length s)))
 	  ;; Blast the string into place.
-	  (sb-kernel:copy-to-system-area (the simple-string s)
+	  (sb-kernel:copy-to-system-area (the simple-base-string
+                                           ;; FIXME
+                                           (coerce s 'simple-base-string))
 					 (* sb-vm:vector-data-offset
 					    sb-vm:n-word-bits)
 					 string-sap 0
@@ -382,6 +384,7 @@
 ;;; Is UNIX-FILENAME the name of a file that we can execute?
 (defun unix-filename-is-executable-p (unix-filename)
   (declare (type simple-string unix-filename))
+  (setf unix-filename (coerce unix-filename 'base-string))
   (values (and (eq (sb-unix:unix-file-kind unix-filename) :file)
 	       (sb-unix:unix-access unix-filename sb-unix:x_ok))))
 
@@ -614,7 +617,7 @@
 ;;; stream.
 (defun copy-descriptor-to-stream (descriptor stream cookie)
   (incf (car cookie))
-  (let ((string (make-string 256))
+  (let ((string (make-string 256 :element-type 'base-char))
 	handler)
     (setf handler
 	  (sb-sys:add-fd-handler
@@ -683,7 +686,7 @@
 	 ;; Use /dev/null.
 	 (multiple-value-bind
 	       (fd errno)
-	     (sb-unix:unix-open "/dev/null"
+	     (sb-unix:unix-open #.(coerce "/dev/null" 'base-string)
 				(case direction
 				  (:input sb-unix:o_rdonly)
 				  (:output sb-unix:o_wronly)
@@ -735,7 +738,7 @@
 	    (dotimes (count
 		       256
 		      (error "could not open a temporary file in /tmp"))
-	      (let* ((name (format nil "/tmp/.run-program-~D" count))
+	      (let* ((name (coerce (format nil "/tmp/.run-program-~D" count) 'base-string))
 		     (fd (sb-unix:unix-open name
 					    (logior sb-unix:o_rdwr
 						    sb-unix:o_creat
diff -urNb sbcl/src/code/seq.lisp sbcl.char/src/code/seq.lisp
--- sbcl/src/code/seq.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/seq.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -569,6 +569,14 @@
   (when (null source-end) (setq source-end (length source-sequence)))
   (mumble-replace-from-mumble))
 
+(defun simple-character-string-replace-from-simple-character-string*
+    (target-sequence source-sequence
+     target-start target-end source-start source-end)
+  (declare (type (simple-array character (*)) target-sequence source-sequence))
+  (when (null target-end) (setq target-end (length target-sequence)))
+  (when (null source-end) (setq source-end (length source-sequence)))
+  (mumble-replace-from-mumble))
+
 (define-sequence-traverser replace
     (sequence1 sequence2 &key start1 end1 start2 end2)
   #!+sb-doc
diff -urNb sbcl/src/code/stream.lisp sbcl.char/src/code/stream.lisp
--- sbcl/src/code/stream.lisp	2004-10-29 14:57:35.000000000 +0200
+++ sbcl.char/src/code/stream.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -433,14 +433,15 @@
 	   (funcall (ansi-stream-in stream) stream eof-error-p eof-value))
 	  (t
 	   (when (/= start +ansi-stream-in-buffer-extra+)
+	     ;; FIXME AARGH KLUDGE There's no sb!vm:n-character-bits.
 	     (bit-bash-copy ibuf (+ (* +ansi-stream-in-buffer-extra+
-				       sb!vm:n-byte-bits)
+				       sb!vm:n-byte-bits 4)
 				    (* sb!vm:vector-data-offset
 				       sb!vm:n-word-bits))
-			    ibuf (+ (the index (* start sb!vm:n-byte-bits))
+			    ibuf (+ (the index (* start sb!vm:n-byte-bits 4))
 				    (* sb!vm:vector-data-offset
 				       sb!vm:n-word-bits))
-			    (* count sb!vm:n-byte-bits)))
+			    (* count sb!vm:n-byte-bits 4)))
 	   (setf (ansi-stream-in-index stream) (1+ start))
 	   (aref ibuf start)))))
 
@@ -1028,7 +1029,7 @@
 	     (:include string-stream
 		       (in #'string-inch)
 		       (bin #'ill-bin)
-		       (n-bin #'string-stream-read-n-bytes)
+		       (n-bin #'ill-bin)
 		       (misc #'string-in-misc)
                        (string (missing-arg) :type simple-string))
 	     (:constructor internal-make-string-input-stream
@@ -1233,14 +1234,19 @@
 	 (element-type (string-output-stream-element-type stream))
 	 (result 
 	  (case element-type
-	    ;; Overwhelmingly common case; can be inlined.
+	    ;; overwhelmingly common case: can be inlined
 	    ((character) (make-string length))
+	    ;; slightly less common cases: inline it anyway
+	    ((base-char standard-char)
+	     (make-string length :element-type 'base-char))
 	    (t (make-string length :element-type element-type)))))
     ;; For the benefit of the REPLACE transform, let's do this, so
     ;; that the common case isn't ludicrously expensive.
     (etypecase result 
       ((simple-array character (*)) 
        (replace result (string-output-stream-string stream)))
+      (simple-base-string
+       (replace result (string-output-stream-string stream)))
       ((simple-array nil (*))
        (replace result (string-output-stream-string stream))))
     (setf (string-output-stream-index stream) 0
@@ -1263,6 +1269,8 @@
 ;;; the CLM, but they are required for the implementation of
 ;;; WITH-OUTPUT-TO-STRING.
 
+;;; FIXME: need to support (VECTOR BASE-CHAR) and (VECTOR NIL),
+;;; ideally without destroying all hope of efficiency.
 (deftype string-with-fill-pointer ()
   '(and (vector character)
 	(satisfies array-has-fill-pointer-p)))
@@ -1292,9 +1300,9 @@
 	(if (= offset-current end)
 	    (let* ((new-length (1+ (* current 2)))
 		   (new-workspace (make-string new-length)))
-	      (declare (simple-string new-workspace))
-	      (%byte-blt workspace start
-			 new-workspace 0 current)
+	      (declare (type (simple-array character (*)) new-workspace))
+              (replace new-workspace workspace
+                       :start2 start :end2 offset-current)
 	      (setf workspace new-workspace
 		    offset-current current)
 	      (set-array-header buffer workspace new-length
@@ -1322,21 +1330,16 @@
 	    (let* ((new-length (+ (the fixnum (* current 2)) string-len))
 		   (new-workspace (make-string new-length)))
 	      (declare (type (simple-array character (*)) new-workspace))
-	      (%byte-blt workspace dst-start
-			 new-workspace 0 current)
-	      (setf workspace new-workspace)
-	      (setf offset-current current)
-	      (setf offset-dst-end dst-end)
-	      (set-array-header buffer
-				workspace
-				new-length
-				dst-end
-				0
-				new-length
-				nil))
+              (replace new-workspace workspace
+                       :start2 dst-start :end2 offset-current)
+	      (setf workspace new-workspace
+                    offset-current current
+                    offset-dst-end dst-end)
+	      (set-array-header buffer workspace new-length
+				dst-end 0 new-length nil))
 	    (setf (fill-pointer buffer) dst-end))
-	(%byte-blt string start
-		   workspace offset-current offset-dst-end)))
+	(replace workspace string
+                 :start1 offset-current :start2 start :end2 end)))
     dst-end))
 
 (defun fill-pointer-misc (stream operation &optional arg1 arg2)
@@ -1525,7 +1528,7 @@
 
 (defun case-frob-upcase-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1550,7 +1553,7 @@
 
 (defun case-frob-downcase-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1583,7 +1586,7 @@
 
 (defun case-frob-capitalize-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1628,7 +1631,7 @@
 
 (defun case-frob-capitalize-aux-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1673,7 +1676,7 @@
 
 (defun case-frob-capitalize-first-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
diff -urNb sbcl/src/code/target-char.lisp sbcl.char/src/code/target-char.lisp
--- sbcl/src/code/target-char.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/target-char.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -32,6 +32,27 @@
 (deftype char-code ()
   `(integer 0 (,char-code-limit)))
 
+(defvar *character-database*)
+
+(macrolet ((frob ()
+             (with-open-file (stream (merge-pathnames
+                                      (make-pathname
+                                       :directory
+                                       '(:relative :up :up "output")
+                                       :name "ucd"
+                                       :type "dat")
+                                      sb!xc:*compile-file-pathname*)
+                                     :direction :input
+                                     :element-type '(unsigned-byte 8))
+               (let* ((length (file-length stream))
+                      (array (make-array length
+                                         :element-type '(unsigned-byte 8))))
+                 (read-sequence array stream)
+                 `(defun !character-database-cold-init ()
+		    (setq *character-database* ',array))))))
+  (frob))
+#+sb-xc-host (!character-database-cold-init)
+
 ;;; This is the alist of (character-name . character) for characters
 ;;; with long names. The first name in this list for a given character
 ;;; is used on typeout and is the preferred form for input.
@@ -40,8 +61,10 @@
 	       (dolist (code char-names-list)
 		 (destructuring-bind (ccode names) code
 		   (dolist (name names)
-		     (results (cons name (code-char ccode))))))
-	       `(defparameter *char-name-alist* ',(results)))))
+		     (results (cons name ccode)))))
+	       `(defparameter *char-name-alist*
+                 (mapcar (lambda (x) (cons (car x) (code-char (cdr x))))
+                         ',(results))))))
   ;; Note: The *** markers here indicate character names which are
   ;; required by the ANSI specification of #'CHAR-NAME. For the others,
   ;; we prefer the ASCII standard name.
@@ -78,15 +101,76 @@
 	 (#x1E ("Rs" "^^"))
 	 (#x1F ("Us" "^_"))
 	 (#x20 ("Space" "Sp")) ; *** See Note above.
-	 (#x7f ("Rubout" "Delete" "Del"))))) ; *** See Note above.
+	 (#x7f ("Rubout" "Delete" "Del"))
+	 (#x80 ("C80"))
+	 (#x81 ("C81"))
+	 (#x82 ("Break-Permitted"))
+	 (#x83 ("No-Break-Permitted"))
+	 (#x84 ("C84"))
+	 (#x85 ("Next-Line"))
+	 (#x86 ("Start-Selected-Area"))
+	 (#x87 ("End-Selected-Area"))
+	 (#x88 ("Character-Tabulation-Set"))
+	 (#x89 ("Character-Tabulation-With-Justification"))
+	 (#x8A ("Line-Tabulation-Set"))
+	 (#x8B ("Partial-Line-Forward"))
+	 (#x8C ("Partial-Line-Backward"))
+	 (#x8D ("Reverse-Linefeed"))
+	 (#x8E ("Single-Shift-Two"))
+	 (#x8F ("Single-Shift-Three"))
+	 (#x90 ("Device-Control-String"))
+	 (#x91 ("Private-Use-One"))
+	 (#x92 ("Private-Use-Two"))
+	 (#x93 ("Set-Transmit-State"))
+	 (#x94 ("Cancel-Character"))
+	 (#x95 ("Message-Waiting"))
+	 (#x96 ("Start-Guarded-Area"))
+	 (#x97 ("End-Guarded-Area"))
+	 (#x98 ("Start-String"))
+	 (#x99 ("C99"))
+	 (#x9A ("Single-Character-Introducer"))
+	 (#x9B ("Control-Sequence-Introducer"))
+	 (#x9C ("String-Terminator"))
+	 (#x9D ("Operating-System-Command"))
+	 (#x9E ("Privacy-Message"))
+	 (#x9F ("Application-Program-Command"))))) ; *** See Note above.
 
 ;;;; accessor functions
 
+;; (* 8 186) => 1488
+;; (+ 1488 (ash #x110000 -8)) => 5840
+(defun ucd-index (char)
+  (let* ((cp (char-code char))
+	 (cp-high (ash cp -8))
+	 (page (aref *character-database* (+ 1488 cp-high))))
+    (+ 5840 (ash page 10) (ash (ldb (byte 8 0) cp) 2))))
+
+(defun ucd-value-0 (char)
+  (aref *character-database* (ucd-index char)))
+
+(defun ucd-value-1 (char)
+  (let ((index (ucd-index char)))
+    (dpb (aref *character-database* (+ index 3))
+	 (byte 8 16)
+	 (dpb (aref *character-database* (+ index 2))
+	      (byte 8 8)
+	      (aref *character-database* (1+ index))))))
+
+(defun ucd-general-category (char)
+  (aref *character-database* (* 8 (ucd-value-0 char))))
+
+(defun ucd-decimal-digit (char)
+  (let ((decimal-digit (aref *character-database*
+			     (+ 3 (* 8 (ucd-value-0 char))))))
+    (when (< decimal-digit 10)
+      decimal-digit)))
+
 (defun char-code (char)
   #!+sb-doc
   "Return the integer code of CHAR."
+  ;; FIXME: do we actually need this?
   (etypecase char
-    (base-char (char-code (truly-the base-char char)))))
+    (character (char-code (truly-the character char)))))
 
 (defun char-int (char)
   #!+sb-doc
@@ -156,41 +240,34 @@
   "The argument must be a character object. GRAPHIC-CHAR-P returns T if the
   argument is a printing character (space through ~ in ASCII), otherwise
   returns NIL."
-  (and (typep char 'base-char)
-       (< 31
-	  (char-code (the base-char char))
-	  127)))
+  (let ((n (char-code char)))
+    (or (< 31 n 127)
+	(< 159 n))))
 
 (defun alpha-char-p (char)
   #!+sb-doc
   "The argument must be a character object. ALPHA-CHAR-P returns T if the
    argument is an alphabetic character, A-Z or a-z; otherwise NIL."
-  (let ((m (char-code char)))
-    (or (< 64 m 91) (< 96 m 123))))
+  (< (ucd-general-category char) 5))
 
 (defun upper-case-p (char)
   #!+sb-doc
   "The argument must be a character object; UPPER-CASE-P returns T if the
    argument is an upper-case character, NIL otherwise."
-  (< 64
-     (char-code char)
-     91))
+  (= (ucd-value-0 char) 0))
 
 (defun lower-case-p (char)
   #!+sb-doc
   "The argument must be a character object; LOWER-CASE-P returns T if the
    argument is a lower-case character, NIL otherwise."
-  (< 96
-     (char-code char)
-     123))
+  (= (ucd-value-0 char) 1))
 
 (defun both-case-p (char)
   #!+sb-doc
   "The argument must be a character object. BOTH-CASE-P returns T if the
   argument is an alphabetic character and if the character exists in
   both upper and lower case. For ASCII, this is the same as ALPHA-CHAR-P."
-  (let ((m (char-code char)))
-    (or (< 64 m 91) (< 96 m 123))))
+  (< (ucd-value-0 char) 2))
 
 (defun digit-char-p (char &optional (radix 10.))
   #!+sb-doc
@@ -208,14 +285,17 @@
 	  ;; Also check lower case a - z.
 	  ((and (>= (setq m (- m 32)) 10) (< m radix)) m)
 	  ;; Else, fail.
-	  (t nil))))
+	  (t (let ((number (ucd-decimal-digit char)))
+	       (when (and number (< number radix))
+		 number))))))
 
 (defun alphanumericp (char)
   #!+sb-doc
   "Given a character-object argument, ALPHANUMERICP returns T if the
    argument is either numeric or alphabetic."
-  (let ((m (char-code char)))
-    (or (< 47 m 58) (< 64 m 91) (< 96 m 123))))
+  (let ((gc (ucd-general-category char)))
+    (or (< gc 5)
+	(= gc 12))))
 
 (defun char= (character &rest more-characters)
   #!+sb-doc
@@ -279,8 +359,11 @@
 ;;;  which loses font, bits, and case info.
 
 (defmacro equal-char-code (character)
-  `(let ((ch (char-code ,character)))
-     (if (< 96 ch 123) (- ch 32) ch)))
+  (let ((ch (gensym)))
+    `(let ((,ch ,character))
+      (if (= (ucd-value-0 ,ch) 0)
+	  (ucd-value-1 ,ch)
+	  (char-code ,ch)))))
 
 (defun char-equal (character &rest more-characters)
   #!+sb-doc
@@ -354,16 +437,17 @@
 
 (defun char-upcase (char)
   #!+sb-doc
-  "Return CHAR converted to upper-case if that is possible."
-  (if (lower-case-p char)
-      (code-char (- (char-code char) 32))
+  "Return CHAR converted to upper-case if that is possible.  Don't convert
+   lowercase eszet (U+DF)."
+  (if (= (ucd-value-0 char) 1)
+      (code-char (ucd-value-1 char))
       char))
 
 (defun char-downcase (char)
   #!+sb-doc
   "Return CHAR converted to lower-case if that is possible."
-  (if (upper-case-p char)
-      (code-char (+ (char-code char) 32))
+  (if (= (ucd-value-0 char) 0)
+      (code-char (ucd-value-1 char))
       char))
 
 (defun digit-char (weight &optional (radix 10))
diff -urNb sbcl/src/code/target-format.lisp sbcl.char/src/code/target-format.lisp
--- sbcl/src/code/target-format.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/target-format.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -76,8 +76,11 @@
 	   (multiple-value-bind (new-directives new-args)
 	       (let* ((character (format-directive-character directive))
 		      (function
+                       (typecase character
+                         (base-char 
 		       (svref *format-directive-interpreters*
 			      (char-code character)))
+                         (character nil)))
 		      (*default-format-error-offset*
 		       (1- (format-directive-end directive))))
 		 (unless function
diff -urNb sbcl/src/code/target-load.lisp sbcl.char/src/code/target-load.lisp
--- sbcl/src/code/target-load.lisp	2004-10-29 14:57:35.000000000 +0200
+++ sbcl.char/src/code/target-load.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -295,4 +295,9 @@
 (defun !loader-cold-init ()
   (/show0 "/!loader-cold-init")
   (dolist (routine *!initial-assembler-routines*)
-    (setf (gethash (car routine) *assembler-routines*) (cdr routine))))
+    (setf (gethash (car routine) *assembler-routines*) (cdr routine)))
+  (dolist (symbol *!initial-foreign-symbols*)
+    (setf (gethash (car symbol) *static-foreign-symbols*) (cdr symbol))))
+
+(declaim (ftype (function (string) (unsigned-byte #.sb!vm:n-machine-word-bits))
+		foreign-symbol-address-as-integer))
diff -urNb sbcl/src/code/target-pathname.lisp sbcl.char/src/code/target-pathname.lisp
--- sbcl/src/code/target-pathname.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/target-pathname.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -44,7 +44,7 @@
   (let ((namestring (handler-case (namestring pathname)
 		      (error nil))))
     (if namestring
-	(format stream "#P~S" namestring)
+	(format stream "#P~S" (coerce namestring '(simple-array character (*))))
 	(print-unreadable-object (pathname stream :type t)
 	  (format stream
 		  "~@<(with no namestring) ~_:HOST ~S ~_:DEVICE ~S ~_:DIRECTORY ~S ~
@@ -202,12 +202,12 @@
   (or (eq thing wild)
       (eq wild :wild)
       (typecase thing
-	(simple-base-string
+	(simple-string
 	 ;; String is matched by itself, a matching pattern or :WILD.
 	 (typecase wild
 	   (pattern
 	    (values (pattern-matches wild thing)))
-	   (simple-base-string
+	   (simple-string
 	    (string= thing wild))))
 	(pattern
 	 ;; A pattern is only matched by an identical pattern.
@@ -308,7 +308,7 @@
 		    (dolist (x in)
 		      (when (check-for pred x)
 			(return t))))
-		   (simple-base-string
+		   (simple-string
 		    (dotimes (i (length in))
 		      (when (funcall pred (schar in i))
 			(return t))))
@@ -319,7 +319,7 @@
 		    (make-pattern
 		     (mapcar (lambda (piece)
 			       (typecase piece
-				 (simple-base-string
+				 (simple-string
 				  (funcall fun piece))
 				 (cons
 				  (case (car piece)
@@ -333,7 +333,7 @@
 			     (pattern-pieces thing))))
 		   (list
 		    (mapcar fun thing))
-		   (simple-base-string
+		   (simple-string
 		    (funcall fun thing))
 		   (t
 		    thing))))
@@ -385,6 +385,7 @@
   (declare (type pathname-designator pathname)
 	   (type pathname-designator defaults)
 	   (values pathname))
+  (/show0 "in MERGE-PATHNAMES")
   (with-pathname (defaults defaults)
     (let ((pathname (let ((*default-pathname-defaults* defaults))
 		      (pathname pathname))))
@@ -702,7 +703,7 @@
 ;;; If NAMESTR begins with a colon-terminated, defined, logical host,
 ;;; then return that host, otherwise return NIL.
 (defun extract-logical-host-prefix (namestr start end)
-  (declare (type simple-base-string namestr)
+  (declare (type simple-string namestr)
 	   (type index start end)
 	   (values (or logical-host null)))
   (let ((colon-pos (position #\: namestr :start start :end end)))
@@ -924,7 +925,7 @@
 (defun substitute-into (pattern subs diddle-case)
   (declare (type pattern pattern)
 	   (type list subs)
-	   (values (or simple-base-string pattern) list))
+	   (values (or simple-string pattern) list))
   (let ((in-wildcard nil)
 	(pieces nil)
 	(strings nil))
@@ -1157,13 +1158,14 @@
   (let ((word (string-upcase word)))
     (dotimes (i (length word))
       (let ((ch (schar word i)))
-	(unless (or (alpha-char-p ch) (digit-char-p ch) (char= ch #\-))
+	(unless (and (typep ch 'standard-char)
+		     (or (alpha-char-p ch) (digit-char-p ch) (char= ch #\-)))
 	  (error 'namestring-parse-error
 		 :complaint "logical namestring character which ~
                              is not alphanumeric or hyphen:~%  ~S"
 		 :args (list ch)
 		 :namestring word :offset i))))
-    word))
+    (coerce word 'base-string)))
 
 ;;; Given a logical host or string, return a logical host. If ERROR-P
 ;;; is NIL, then return NIL when no such host exists.
@@ -1257,7 +1259,7 @@
 ;;; Break up a logical-namestring, always a string, into its
 ;;; constituent parts.
 (defun parse-logical-namestring (namestr start end)
-  (declare (type simple-base-string namestr)
+  (declare (type simple-string namestr)
 	   (type index start end))
   (collect ((directory))
     (let ((host nil)
@@ -1418,7 +1420,7 @@
       (when type-supplied
 	(unless name
 	  (error "cannot specify the type without a file: ~S" pathname))
-	(when (typep type 'simple-base-string)
+	(when (typep type 'simple-string)
 	  (when (position #\. type)
 	    (error "type component can't have a #\. inside: ~S" pathname)))
 	(strings ".")
@@ -1524,12 +1526,9 @@
     (t (translate-logical-pathname (pathname pathname)))))
 
 (defvar *logical-pathname-defaults*
-  (%make-logical-pathname (make-logical-host :name "BOGUS")
-			  :unspecific
-			  nil
-			  nil
-			  nil
-			  nil))
+  (%make-logical-pathname
+   (make-logical-host :name (logical-word-or-lose "BOGUS"))
+   :unspecific nil nil nil nil))
 
 (defun load-logical-pathname-translations (host)
   #!+sb-doc
diff -urNb sbcl/src/code/target-thread.lisp sbcl.char/src/code/target-thread.lisp
--- sbcl/src/code/target-thread.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/target-thread.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -58,7 +58,7 @@
 (declaim (inline waitqueue-data-address mutex-value-address))
 
 (defstruct waitqueue
-  (name nil :type (or null simple-base-string))
+  (name nil :type (or null simple-string))
   (lock 0)
   (data nil))
 
diff -urNb sbcl/src/code/target-unithread.lisp sbcl.char/src/code/target-unithread.lisp
--- sbcl/src/code/target-unithread.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/target-unithread.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -37,7 +37,7 @@
 ;;;; the higher-level locking operations are based on waitqueues
 
 (defstruct waitqueue
-  (name nil :type (or null simple-base-string))
+  (name nil :type (or null simple-string))
   (lock 0)
   (data nil))
 
diff -urNb sbcl/src/code/toplevel.lisp sbcl.char/src/code/toplevel.lisp
--- sbcl/src/code/toplevel.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/toplevel.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -421,6 +421,7 @@
              (probe-init-files (explicitly-specified-init-file-name
 				&rest default-init-file-names)
                (declare (type list default-init-file-names))
+	       (/show0 "in PROBE-INIT-FILES")
 	       (if explicitly-specified-init-file-name
 		   (or (probe-file explicitly-specified-init-file-name)
                         (startup-error "The file ~S was not found."
@@ -431,6 +432,7 @@
 	     ;; shared idiom for creating default names for
 	     ;; SYSINITish and USERINITish files
 	     (init-file-name (maybe-dir-name basename)
+	       (/show0 "in INIT-FILE-NAME")
 	       (and maybe-dir-name
 		    (concatenate 'string maybe-dir-name "/" basename))))
         (let ((sysinit-truename
diff -urNb sbcl/src/code/typecheckfuns.lisp sbcl.char/src/code/typecheckfuns.lisp
--- sbcl/src/code/typecheckfuns.lisp	2004-10-28 22:28:37.000000000 +0200
+++ sbcl.char/src/code/typecheckfuns.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -203,7 +203,7 @@
            (intersection-type-p ctype)
            (union-type-p ctype)
            (negation-type-p ctype)
-           (character-set-type-p ctype))))
+	   (character-range-type-p ctype))))
 
 ;;; Evaluate (at load/execute time) to a function which checks that
 ;;; its argument is of the specified type.
diff -urNb sbcl/src/code/unix.lisp sbcl.char/src/code/unix.lisp
--- sbcl/src/code/unix.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/code/unix.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -811,7 +811,7 @@
 ;;; paths have been converted to absolute paths, so we don't need to
 ;;; try to handle any more generality than that.
 (defun unix-resolve-links (pathname)
-  (declare (type simple-string pathname))
+  (declare (type simple-base-string pathname))
   (aver (not (relative-unix-pathname? pathname)))
   (/noshow "entering UNIX-RESOLVE-LINKS")
   (loop with previous-pathnames = nil do
@@ -837,7 +837,7 @@
 							:from-end t)))
 				 (dir (subseq pathname 0 dir-len)))
 			    (/noshow dir)
-			    (concatenate 'string dir link))
+			    (concatenate 'base-string dir link))
 			  link))))
 		(if (unix-file-kind new-pathname)
 		    (setf pathname new-pathname)
@@ -853,9 +853,9 @@
 	    (push pathname previous-pathnames))))
 
 (defun unix-simplify-pathname (src)
-  (declare (type simple-string src))
+  (declare (type simple-base-string src))
   (let* ((src-len (length src))
-	 (dst (make-string src-len))
+	 (dst (make-string src-len :element-type 'base-char))
 	 (dst-len 0)
 	 (dots 0)
 	 (last-slash nil))
@@ -929,7 +929,8 @@
 		  (position #\/ dst :end last-slash :from-end t)))
 	     (if prev-prev-slash
 		 (setf dst-len (1+ prev-prev-slash))
-		 (return-from unix-simplify-pathname "./")))))))
+		 (return-from unix-simplify-pathname
+		   (coerce "./" 'simple-base-string))))))))
     (cond ((zerop dst-len)
 	   "./")
 	  ((= dst-len src-len)
diff -urNb sbcl/src/cold/warm.lisp sbcl.char/src/cold/warm.lisp
--- sbcl/src/cold/warm.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/cold/warm.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -73,10 +73,13 @@
 	 (make-pathname :directory '(:relative "contrib" :wild-inferiors)
 			:name :wild :type :wild)
 	 sys)))
+  (sb-int:/show "about to set SYS logical pathname translations")
   (setf (logical-pathname-translations "SYS")
 	`(("SYS:SRC;**;*.*.*" ,src)
 	  ("SYS:CONTRIB;**;*.*.*" ,contrib))))
 
+(sb-int:/show "set SYS logical pathname translations")
+
 ;;; FIXME: CMU CL's pclcom.lisp had extra optional stuff wrapped around
 ;;; COMPILE-PCL, at least some of which we should probably have too:
 ;;;
@@ -175,7 +178,7 @@
 		;; facility, and should be compiled and loaded after
 		;; our DESCRIBE facility is compiled and loaded.
 		"SRC;PCL;DESCRIBE"))
-
+  (sb-int:/show "at head of DOLIST")
   (let ((fullname (concatenate 'string "SYS:" stem ".LISP")))
     (sb-int:/show "about to compile" fullname)
     (flet ((report-recompile-restart (stream)
diff -urNb sbcl/src/compiler/array-tran.lisp sbcl.char/src/compiler/array-tran.lisp
--- sbcl/src/compiler/array-tran.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/compiler/array-tran.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -293,8 +293,7 @@
       (give-up-ir1-transform
        "cannot open-code creation of ~S" result-type-spec))
     #-sb-xc-host
-    (unless (csubtypep (ctype-of (sb!vm:saetp-initial-element-default saetp))
-		       eltype-type)
+    (unless (ctypep (sb!vm:saetp-initial-element-default saetp) eltype-type)
       ;; This situation arises e.g. in (MAKE-ARRAY 4 :ELEMENT-TYPE
       ;; '(INTEGER 1 5)) ANSI's definition of MAKE-ARRAY says "If
       ;; INITIAL-ELEMENT is not supplied, the consequences of later
diff -urNb sbcl/src/compiler/assem.lisp sbcl.char/src/compiler/assem.lisp
--- sbcl/src/compiler/assem.lisp	2004-10-26 22:40:32.000000000 +0200
+++ sbcl.char/src/compiler/assem.lisp	2004-10-29 15:19:19.000000000 +0200
@@ -27,7 +27,7 @@
 ;;; This structure holds the state of the assembler.
 (defstruct (segment (:copier nil))
   ;; the name of this segment (for debugging output and stuff)
-  (name "unnamed" :type simple-base-string)
+  (name "unnamed" :type simple-string)
   ;; Ordinarily this is a vector where instructions are written. If
   ;; the segment is made invalid (e.g. by APPEND-SEGMENT) then the
   ;; vector can be replaced by NIL.
